from bs4 import BeautifulSoup
from spacy_extensions.parsers.base import ParserHTML

class ParserMalwarebytes(ParserHTML):
    """Parser for CTI reports from blog.malwarebytes.com."""

    def parse_specific(self, html: BeautifulSoup) -> str:
        """Parse beautifulsoup, should be implemented by subparsers.
        
            Parameters
            ----------
            html : BeautifulSoup
                Soup to parse.
                
            Returns
            -------
            text : str
                Content of HTML file.
            """
        # Get title content
        title = self.get_subtag(html, "h1", class_="entry-title").get_text()
        
        # Get article content
        article = html.find_all("div", id="articleBody")[0]

        # Decompose related
        self.get_subtag(article, 'div', id='jp-relatedposts').decompose()

        # Get text
        return '\n\n'.join((title, article.get_text()))